<?php

 defined('JPATH_BASE') or die;
 

  class plgUserMpprofile1 extends JPlugin
  {
	/**
	 * @param	string	The context for the data
	 * @param	int		The user id
	 * @param	object
	 * @return	boolean
	 * @since	1.6
	 */
	function onContentPrepareData($context, $data)
	{
		// Check we are manipulating a valid form.
		if (!in_array($context, array('com_users.profile','com_users.registration','com_users.user','com_admin.profile'))){
			return true;
		}
 
		$userId = isset($data->id) ? $data->id : 0;
 
		// Load the profile data from the database.
		$db = &JFactory::getDbo();
		$db->setQuery(
			'SELECT profile_key, profile_value FROM #__user_profiles' .
			' WHERE user_id = '.(int) $userId .
			' AND profile_key LIKE \'mpprofile1.%\'' .
			' ORDER BY ordering'
		);
		$results = $db->loadRowList();
 
		// Check for a database error.
		if ($db->getErrorNum()) {
			$this->_subject->setError($db->getErrorMsg());
			return false;
		}
 
		// Merge the profile data.
		$data->mpprofile1 = array();
		foreach ($results as $v) {
			$k = str_replace('mpprofile1.', '', $v[0]);
			$data->mpprofile1[$k] = $v[1];
		}
 
		return true;
	}
 
	/**
	 * @param	JForm	The form to be altered.
	 * @param	array	The associated data for the form.
	 * @return	boolean
	 * @since	1.6
	 */
	function onContentPrepareForm($form, $data)
	{
		// Load user_profile plugin language
		$lang = JFactory::getLanguage();
		$lang->load('plg_user_mpprofile1', JPATH_ADMINISTRATOR);
 
		if (!($form instanceof JForm)) {
			$this->_subject->setError('JERROR_NOT_A_FORM');
			return false;
		}
		// Check we are manipulating a valid form.
		if (!in_array($form->getName(), array('com_users.profile', 'com_users.registration','com_users.user','com_admin.profile'))) {
			return true;
		}
		if ($form->getName()=='com_users.profile') {
			// Add the profile fields to the form.
			JForm::addFormPath(dirname(__FILE__).'/profiles');
			$form->loadFile('profile', false);
 
			// Nombre Artístico:
			if ($this->params->get('profile-require_nombreartistico', 1) > 0) {
				$form->setFieldAttribute('nombreartistico', 'required', $this->params->get('profile-require_nombreartistico') == 2, 'mpprofile1');
			} else {
				$form->removeField('nombreartistico', 'mpprofile1');
			}
			
			// nif:
			if ($this->params->get('profile-require_nif', 1) > 0) {
				$form->setFieldAttribute('nif', 'required', $this->params->get('profile-require_nif') == 2, 'mpprofile1');
			} else {
				$form->removeField('nif', 'mpprofile1');
			}
			
			// nacionalidad:
			if ($this->params->get('profile-require_nacionalidad', 1) > 0) {
				$form->setFieldAttribute('nacionalidad', 'required', $this->params->get('profile-require_nacionalidad') == 2, 'mpprofile1');
			} else {
				$form->removeField('nacionalidad', 'mpprofile1');
			}
			
			// fecha nacimiento:
			if ($this->params->get('profile-require_fechanacimiento', 1) > 0) {
				$form->setFieldAttribute('fechanacimiento', 'required', $this->params->get('profile-require_fechanacimiento') == 2, 'mpprofile1');
			} else {
				$form->removeField('fechanacimiento', 'mpprofile1');
			}
			
			// fecha defuncion:
			if ($this->params->get('profile-require_fechadefuncion', 1) > 0) {
				$form->setFieldAttribute('fechadefuncion', 'required', $this->params->get('profile-require_fechadefuncion') == 2, 'mpprofile1');
			} else {
				$form->removeField('fechadefuncion', 'mpprofile1');
			}		
				
			// email privado:
			if ($this->params->get('profile-require_emailprivado', 1) > 0) {
				$form->setFieldAttribute('emailprivado', 'required', $this->params->get('profile-require_emailprivado') == 2, 'mpprofile1');
			} else {
				$form->removeField('emailprivado', 'mpprofile1');
			}
			
			// datos bancarios:
			if ($this->params->get('profile-require_datosbancarios', 1) > 0) {
				$form->setFieldAttribute('datosbancarios', 'required', $this->params->get('profile-require_datosbancarios') == 2, 'mpprofile1');
			} else {
				$form->removeField('datosbancarios', 'mpprofile1');
			}
			
			// biografia :
			if ($this->params->get('profile-require_biografia', 1) > 0) {
				$form->setFieldAttribute('biografia', 'required', $this->params->get('profile-require_biografia') == 2, 'mpprofile1');
			} else {
				$form->removeField('biografia', 'mpprofile1');
			}
		}
 
		//In this example, we treat the frontend registration and the back end user create or edit as the same. 
		elseif ($form->getName()=='com_users.registration' || $form->getName()=='com_users.user' )
		{		
			// Add the registration fields to the form.
			JForm::addFormPath(dirname(__FILE__).'/profiles');
			$form->loadFile('profile', false);
 
			// Nombre Artístico:
			if ($this->params->get('register-require_nombreartistico', 1) > 0) {
				$form->setFieldAttribute('nombreartistico', 'required', $this->params->get('register-require_nombreartistico') == 2, 'mpprofile1');
			} else {
				$form->removeField('nombreartistico', 'mpprofile1');
			}
			
			// nif:
			if ($this->params->get('register-require_nif', 1) > 0) {
				$form->setFieldAttribute('nif', 'required', $this->params->get('register-require_nif') == 2, 'mpprofile1');
			} else {
				$form->removeField('nif', 'mpprofile1');
			}
			
			// nacionalidad:
			if ($this->params->get('register-require_nacionalidad', 1) > 0) {
				$form->setFieldAttribute('nacionalidad', 'required', $this->params->get('register-require_nacionalidad') == 2, 'mpprofile1');
			} else {
				$form->removeField('nacionalidad', 'mpprofile1');
			}
			
			// fecha nacimiento:
			if ($this->params->get('register-require_fechanacimiento', 1) > 0) {
				$form->setFieldAttribute('fechanacimiento', 'required', $this->params->get('register-require_fechanacimiento') == 2, 'mpprofile1');
			} else {
				$form->removeField('fechanacimiento', 'mpprofile1');
			}	
					
			// fecha defuncion:
			if ($this->params->get('register-require_fechadefuncion', 1) > 0) {
				$form->setFieldAttribute('fechadefuncion', 'required', $this->params->get('register-require_fechadefuncion') == 2, 'mpprofile1');
			} else {
				$form->removeField('fechadefuncion', 'mpprofile1');
			}
			
			// email privado:
			if ($this->params->get('register-require_emailprivado', 1) > 0) {
				$form->setFieldAttribute('emailprivado', 'required', $this->params->get('register-require_emailprivado') == 2, 'mpprofile1');
			} else {
				$form->removeField('emailprivado', 'mpprofile1');
			}
			
			// datos bancarios:
			if ($this->params->get('register-require_datosbancarios', 1) > 0) {
				$form->setFieldAttribute('datosbancarios', 'required', $this->params->get('register-require_datosbancarios') == 2, 'mpprofile1');
			} else {
				$form->removeField('datosbancarios', 'mpprofile1');
			}
			
			
			// biografia :
			if ($this->params->get('register-require_biografia', 1) > 0) {
				$form->setFieldAttribute('biografia', 'required', $this->params->get('register-require_biografia') == 2, 'mpprofile1');
			} else {
				$form->removeField('biografia', 'mpprofile1');
			}
			
		}			
	}
 
	function onUserAfterSave($data, $isNew, $result, $error)
	{
		$userId	= JArrayHelper::getValue($data, 'id', 0, 'int');
 
		if ($userId && $result && isset($data['mpprofile1']) && (count($data['mpprofile1'])))
		{
			try
			{
				$db = &JFactory::getDbo();
				$db->setQuery('DELETE FROM #__user_profiles WHERE user_id = '.$userId.' AND profile_key LIKE \'mpprofile1.%\'');
				if (!$db->query()) {
					throw new Exception($db->getErrorMsg());
				}
 
				$tuples = array();
				$order	= 1;
				foreach ($data['mpprofile1'] as $k => $v) {
					$tuples[] = '('.$userId.', '.$db->quote('mpprofile1.'.$k).', '.$db->quote($v).', '.$order++.')';
				}
 
				$db->setQuery('INSERT INTO #__user_profiles VALUES '.implode(', ', $tuples));
				if (!$db->query()) {
					throw new Exception($db->getErrorMsg());
				}
			}
			catch (JException $e) {
				$this->_subject->setError($e->getMessage());
				return false;
			}
		}
 
		return true;
	}
 
	/**
	 * Remove all user profile information for the given user ID
	 *
	 * Method is called after user data is deleted from the database
	 *
	 * @param	array		$user		Holds the user data
	 * @param	boolean		$success	True if user was succesfully stored in the database
	 * @param	string		$msg		Message
	 */
	function onUserAfterDelete($user, $success, $msg)
	{
		if (!$success) {
			return false;
		}
 
		$userId	= JArrayHelper::getValue($user, 'id', 0, 'int');
 
		if ($userId)
		{
			try
			{
				$db = JFactory::getDbo();
				$db->setQuery(
					'DELETE FROM #__user_profiles WHERE user_id = '.$userId .
					" AND profile_key LIKE 'mpprofile1.%'"
				);
 
				if (!$db->query()) {
					throw new Exception($db->getErrorMsg());
				}
			}
			catch (JException $e)
			{
				$this->_subject->setError($e->getMessage());
				return false;
			}
		}
 
		return true;
	}
 
 
 }